"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const qs = require("qs");
class DrupalJsonApiParams {
    constructor() {
        this.filter = {};
    }
    addFilter(path, value, operator = '=', group) {
        if (operator === '=' && group === undefined && this.filter[path] === undefined) {
            this.filter[path] = value;
            return this;
        }
        const name = this.getIndexId(this.filter, path);
        this.filter[name] = {
            condition: Object.assign(Object.assign({ path,
                value }, (operator !== '=' && { operator })), (group !== undefined && { group })),
        };
        return this;
    }
    getIndexId(obj, proposedKey) {
        let key;
        if (obj[proposedKey] === undefined) {
            key = proposedKey;
        }
        else {
            key = Object.keys(obj).length.toString();
        }
        return key;
    }
    getQueryString() {
        const data = {
            filter: this.filter,
        };
        return qs.stringify(data);
    }
}
exports.DrupalJsonApiParams = DrupalJsonApiParams;
